:- ensure_loaded( library(ordsets) ).	% ord_member/2.

asia_blanket( [1-[2],2-[1,3,5],3-[2,5,6,7,8],4-[5,6],5-[2,3,4],6-[3,4,8],7-[3],8-[3,6]] ).

distance_of( File, Distance ) :-
	see( File ),
	read( blanket_counts(Blanket) ),
	seen,
	asia_blanket( Ref ),
	blanket_distance( Blanket, Ref, 0, Distance ).

% blanket_distance( Blanket, Ref, Distance ) :-
blanket_distance( Blanket, Ref, Distance ) :-
	blanket_distance( Blanket, Ref, 0, Distance ).

blanket_distance( [], [], Distance, Distance ).
blanket_distance( [H-Hmb|T], [H-Rfmb|Trf], Acc, Distance ) :-
	markov_blanket_distance( Hmb, Rfmb, Acc, NxAcc ),
	blanket_distance( T, Trf, NxAcc, Distance ).

markov_blanket_distance( [], _Ref, Distance, Distance ).
markov_blanket_distance( [Node-Freq|T], Ref, Acc, Distance ) :-
	( ord_member(Node,Ref) ->
		NxAcc is Acc + ( 1 - Freq )
		;
		NxAcc is Acc + Freq
	),
	markov_blanket_distance( T, Ref, NxAcc, Distance ).
