zero_parents( [Z,Z,Z,Z,Z,Z,Z,Z] ) :-
	Z = [0,0,0,0,0,0,0,0].

main( [File] ) :-
	open( File, read, Stream ),
	zero_parents( Zero ),
	count_parents( Stream, 1, Zero, Parents, Total ),
	close( Stream ),
	print_parents( Parents, Total, 1 ).

count_parents( Stream, Nth, Acc, Parents, Total ) :-
	read_term( Stream, Term ),
	( Term = end_of_file ->
		Total = Nth, Parents = Acc
		;
		Term = c(CList),
		increment_counts( CList, Acc, NxAcc ),
		count_parents( Stream, Nth, Acc, Parents, Total )
	).

increment_counts( [], _Empty, [] ).
increment_counts( [_Nth-Parents|Tp], [Ha|Ta], [Hn|Tn] ) :-
	add_to_those( Parents, 0, Ha, Hn ),
	increment_counts( Tp, Ta, Tn ).

add_to_those( [], _Last, Acc, Acc ).
add_to_those( [H|T], Last, Acc, Res ) :-
	Nth is H - Last,
	increment_this( Nth, Acc, TAcc, Res, TRes ),
	add_to_those( T, H, TAcc, TRes ).

increment_this( Nth, [H|T], TAcc, [Hi|Ti], TRes ) :-
	( Nth =:= 1 ->
		Hi is H + 1,
		TAcc = T,
		TRes = Ti
		;
		NxN is Nth - 1,
		Hi = H,
		increment_this( NxN, T, TAcc, Ti, TRes )
	).

