:- ensure_loaded( '../src/init_lib' ).

:- ensure_loaded( library(file_to_list_of_lines) ).
:- ensure_loaded( library(breaks_list) ).
:- ensure_loaded( disp_bn ).
:- ensure_loaded( library(lists) ). 				% append/3,reverse/2.
:- pl( sicstus(_S), ensure_loaded(library(number_atom)) ). % /2.
:- pl( yap(_Y), ensure_loaded(library(at_end_of_line)) ).
:- ensure_loaded( library(kv_decompose) ). 			% /3.


counts_to_prb_lists( File, SortLists ) :-
	file_to_list_of_lines( File, Lines ),
	counts_lines_to_prb_lists( Lines, PrbLists ),
	keysort( PrbLists, SortLists ).

counts_lines_to_prb_lists( Lines, PrbLists ) :-
	( has_node_with_lines( Lines, Node, NodeLines, RestLines ) ->
		node_lines_to_prbs( NodeLines, [], NodePrbs ),
		write( nodeprbs(NodePrbs) ), nl,
		PrbLists = [Node-NodePrbs|TPrbLists],
		counts_lines_to_prb_lists( RestLines, TPrbLists )
		;
		PrbLists = []
	).

has_node_with_lines( Lines, Node, NodeLines, RestLines ) :-
	TpPred = append("Parent counts for ",NodeCsCol,E),
	breaks_list(Lines,TpPred,E,_LeftLns,_The,RightLns),
	append( NodeCs, [0':|_Rest], NodeCsCol ),
	number_codes( Node, NodeCs ),
	BtPred = append("Parent counts for ",_OthCs,BtE),
	( breaks_list(RightLns,BtPred,BtE,NodeLines,TheLn,RRemLns) ->
		RestLines = [TheLn|RRemLns]
		;
		RestLines = [],
		NodeLines = RightLns
	).

node_lines_to_prbs( [], Acc, Prbs ) :-
	%reverse( Acc, Prbs ).
	keysort( Acc, Sort ),
	kv_decompose( Sort, _Keys, Prbs ).
node_lines_to_prbs( [H|T], AccIn, Prbs ) :-
	node_line_to_prb( H, AccIn, AccMid ),
	node_lines_to_prbs( T, AccMid, Prbs ).

node_line_to_prb( [], Acc, Acc ).
node_line_to_prb( Line, AccIn, AccOut ) :-
	( append( Left, [0' |Right], Line ) ->
		number_codes( Prb, Right ),
		number_codes( Parent, Left ),
		AccOut = [Parent-Prb|AccIn]
		;
		write( node_line_to_parent(unrecognisided_line_format(Line)) ), nl,
		abort
	).
