% :- module( visits, [visits/2] ).

:- ensure_loaded( '../src/init_lib' ).
:- ensure_loaded( library(term_in_file_contiguous_counts) ).
:- ensure_loaded( library(kv_additive_consolidation) ).
:- ensure_loaded( library(kv_transpose) ).
:- ensure_loaded( library(kv_decompose) ).
:- ensure_loaded( library(default_tmp_directory) ).		% /1.
:- ensure_loaded( library(mktemp_in_dir) ).				% /3.
:- ensure_loaded( library(write_list_elem_per_line) ).		% /1.
:- ensure_loaded( library(flatoms) ).					% /2.
:- ensure_loaded( library(gnucomfile_w_lines) ).			% /2.
% :- ensure_loaded( library(wake_up) ).					% /0.

visits( BareFile, _VisFile ) :-
	term_in_file_contiguous_counts( BareFile, c( _Any ), RevCounts ),
	reverse( RevCounts, Counts ),
	kv_decompose( Counts, _CountsKeys, CountsValues ),
	kv_additive_consolidation( Counts, Consol ),
	kv_transpose( Consol, Trans ),
	keysort( Trans, TranSort ),
	kv_decompose( TranSort, AdditiveKeys, _Values ),
	% default_tmp_directory( TmpDir ),
	flatoms( [BareFile,'.stays'], DataFile1 ),
	flatoms( [BareFile,'.visits'], DataFile2 ),
	% % mktemp_in_dir( gnuplotdata_XXXXXX, '.', DataFile1 ),
	% % mktemp_in_dir( gnuplotdata_XXXXXX, '.', DataFile2 ),
	% mktemp_in_dir( gnuplotcoms_XXXXXX, '.', GnuComsFile ),
	current_output( OldOut ),
	tell( DataFile1 ),
	write_list_elem_per_line( CountsValues ), 
	told,
	tell( DataFile2 ),
	write_list_elem_per_line( AdditiveKeys ), 
	told,
	set_output( OldOut ).
	
	/* ,
	flatoms( ['gnuplot -persist \"',GnuComsFile,'\"'], Gplot1 ),
	gnucomfile_w_lines( GnuComsFile, DataFile1 ),
	exec( Gplot1, [null,null,null], _Pid1 ),
	sleep( 3 ),
	gnucomfile_w_lines( GnuComsFile, DataFile2 ),
	exec( Gplot1, [null,null,null], _Pid2 ),
	sleep( 2 ),
	% delete_file( DataFile1 ),
	% delete_file( DataFile2 ),
	delete_file( GnuComsFile ).
	% wake_up.
	*/ 
