:- ensure_loaded( '../src/init_lib' ).

:- ensure_loaded( library(default_tmp_directory) ).	% /1.
:- ensure_loaded( library(mktemp_in_dir) ).			% /3.
:- ensure_loaded( library(bn_to_dot_dag) ).			% /3.
:- ensure_loaded( library(mktemp_in_dir) ).			% /3.
:- ensure_loaded( library(system) ).		% /1.
:- prolog_load_context( directory, LoadDir ), 
   atom_codes( LoadDir, LoadDirCs ),
   bb_put( disp_dag_directory, LoadDirCs ).

% disp_bn( [1-[],2-[1],3-[2,5],4-[],5-[4],6-[4],7-[3],8-[3,6]] ).
% disp_bn( [1-[],2-[1,4],3-[1],4-[1],5-[],6-[],7-[1,2,3,4,5,6],8-[2]], [1-[],2-[1],3-[2,5],4-[],5-[4],6-[4],7-[3],8-[3,6]] ).
% red edges (ok) yellow edges (new) magenta (missing)
% disp_dag /usr/nicos/islp/bn_lbl_kernel/slp/disp/asia.dot 
% /local/usr/src/graphviz-1.10/tcldot/demo/doted
% 
disp_asia([]) :- 
	disp_asia.
disp_asia :- 
	disp_bn( [1-[],2-[1],3-[2,5],4-[],5-[4],6-[4],7-[3],8-[3,6]] ).

disp_bn( Bn ) :-
	disp_bn( Bn, Bn ).

disp_bn( Bn, Against ) :-
	default_tmp_directory( TmpDir ),
	mktemp_in_dir( tmp_XXXXXX, TmpDir, DotFile ),
	bn_to_dot_dag( Bn, Against, DotFile ),
	exec_dag_disp( DotFile ).

exec_dag_disp( DotFile ) :-
	atom_codes( DotFile, DotFileCs ),
	% flatten( ["disp_dag ",DotFileCs," >& /dev/null "," ; rm -f ",DotFileCs], DispCs ),
	bb_get( disp_dag_directory, DispDagDirCs ),
	% flatten( ["echo $TCLLIBPATH > tcllibpath ; ",DispDagDirCs,"/disp_dag ",DotFileCs," ; rm -f ",DotFileCs], DispCs ),
	( shell(' which doted ' ) ->
		Doted = "doted " 
		;
		flatten( [DispDagDirCs,"/disp_dag "], Doted )
	),
	write( doted(Doted) ), nl,
	flatten( [Doted,DotFileCs," >& /dev/null "," ; rm -f ",DotFileCs], DispCs ),
	atom_codes( Disp, DispCs ),
	write( shell( Disp ) ), nl,
	% open_null_stream( Dnull ),
	% prolog_flag( user_error, Cuerr, Dnull ),
	exec( Disp, [null,null,null], _Pid ).
	% prolog_flag( user_error, _Dnull, Cuerr ),
	% close( Dnull ).
