:- ensure_loaded( '../src/all_dynamic'  ).	%
:- ensure_loaded( '../src/ad_to_slp'  ).	%
:- ensure_loaded( '../src/lib/lss'  ).	%

:- ensure_loaded( library(lists) ).	% append/3.
:- ensure_loaded( disp_bn ).			% /1.

:- ensure_loaded( library(random) ).			% /1.

:- prolog_load_context( directory, LoadDir ), atom_codes( LoadDir, LoadDirCs ),
   bb_put( auxil_dir, LoadDirCs ).

/*
disp_sbns( bn_un_2p, 10000, stop, [1,2,3,4,5,6,7,8] ). 
disp_sbns( bn_un_2p, 10, donot_stop, [1,2,3,4,5,6,7,8] ). 
disp_sbns( bn_un_2p, 10, donot_stop, [a,b,c,d,e,f,g,h] ). 
*/
disp_sbns( SlpFile, NBns, Stop, Nodes ) :-
	% setrand(rand(1201,66,20203)).
	atom_codes( SlpFile, FileCs ),
	bb_get( auxil_dir, AuxilCs ),
	append( AuxilCs, "/../slp/", PreFxCs ),
	append( PreFxCs, FileCs, MidFxCs ),
	append( MidFxCs, ".slp", FullCs ),
	atom_codes( Full, FullCs ),
	all_dynamic( Full ),
	ad_to_slp( [pred_type(_A,_B),s_label(_C,_D)], googles_tmp ),
	% tell( ResFile ),
	gen_and_disp_nbns( NBns, Nodes, Stop ).
	% told.

gen_and_disp_nbns( N, Nodes, Stop ) :-
	( N =:= 0 ->
		true
		;
		NxN is N - 1,
		slp:bn( _A, _B, _C/[], Nodes, Bn ),
		!,
		write( c(Bn) ), write( '.' ), nl,
		disp_bn( Bn ),
		( Stop == stop ->
			write( ' press return to continue (or, q followed by return to quit)' ),
			get_code(Inp), nl,
			( Inp == 0'q ->
				abort
				;
				true
			)
			;
			true
		),
		gen_and_disp_nbns( NxN, Nodes, Stop )
		
		% ( top_sort( Bn, _Sorted ) ->
			% write( c(Bn) ), write( '.' ), nl,
			% gen_bns( NxN, Nodes )
			% ;
			% gen_bns( NxN, Nodes )
			% write( user_error, found_cycle(Bn) ), nl( user_error),
			% abort
		% )
	).
