:- ensure_loaded( '../main_load'  ).	% main/1.
:- ensure_loaded( library(lists) ).		% append/3.

% gen( bn_2pun_3h25, sampled_tenK_bn_2pun_3h25, 10000, [1,2,3,4,5,6,7,8] ). 
gen( SlpFile, ResFile, NBns, Nodes ) :-
	atom_codes( SlpFile, FileCs ),
	append( "../slp/", FileCs, PrefixCs ),
	append( PrefixCs, ".slp", FullCs ),
	atom_codes( Full, FullCs ),
	main( Full ),
	tell( ResFile ),
	gen_bns( NBns, Nodes ),
	told.

gen_bns( N, Nodes ) :-
	( N =:= 0 ->
		true
		;
		NxN is N - 1,
		slp:bn( _A, _B, _C/[], Nodes, Bn ),
		!,
		( top_sort( Bn, _Sorted ) ->
			write( c(Bn) ), write( '.' ), nl,
			gen_bns( NxN, Nodes )
			;
			write( user_error, found_cycle(Bn) ), nl( user_error),
			abort
		)
	).
