:- use_module( library(random) ).

main([]) :-
	main.

main :-
	getrand( GenSeeds ),
	open( seeds, write, Stream ),
	write( Stream, gen_seeds(GenSeeds) ),
	write( Stream, '.' ), nl( Stream ),
	gen_seeds( 1000, 1000, Stream ),
	close( Stream ).

gen_seeds( Rem, Orig, Stream ) :-
	( Rem =:= 0 ->
		true
		;
		random( 1, 30269, X ),
		random( 1, 30307, Y ),
		random( 1, 30323, Z ),
		Inx is Orig - Rem + 1,
		write( Stream, seed( Inx, rand(X,Y,Z)) ),
		write( Stream, '.' ), nl( Stream ),
		StillLeft is Rem - 1,
		gen_seeds( StillLeft, Orig, Stream )
	).
