:- ensure_loaded( '../src/init_lib' ).
:- ensure_loaded( library(lists) ).          % memberchk/2
:- ensure_loaded( library(flatoms) ).		% /2.
:- ensure_loaded( library(sys_info) ).       % /1.

:- ensure_loaded( 'create_visits' ).		
:- ensure_loaded( 'create_blankets' ).		
% :- ensure_loaded( 'create_graphs' ).

% gz_to_extensions( ['/local/tara/lnai/yap_srk/tr_vp28_or_2p_i500K_all_s1.gz',counts,blankets,visits] ).
gz_to_extensions( [Gz|Exts] ) :-
	atom_codes( Gz, GzCs ),
	append( DirFCs, ".gz", GzCs ), 
	atom_codes( DirF, DirFCs ),
	flatoms( ['gunzip -c ',Gz, ' > ', DirF], Gunzip ),
	sys_info( Gunzip ),
	exec_extensions( Exts, DirF ),
	flatoms( ['rm -f ', DirF], Rm ),
	sys_info( Rm ).

exec_extensions( [], _DirF ).
exec_extensions( [H|T], DirF ) :-
	exec_extension( H, DirF ),
	exec_extensions( T, DirF ).

exec_extension( counts, DirF ) :-
	!,
	flatoms( ['jc_count_parents.perl',' ',DirF, '> ',DirF,'.',counts,
				' 2>> /dev/null'],
				ExecH ),
	% write( std_exec(ExecH) ), nl,
	% exec( ExecH, [std,std,std], _Pid ).
	sys_info( ExecH ).
exec_extension( H, DirF ) :-
	( memberchk(H,[blankets,graphs,visits]) -> 
		flatoms( [DirF,'.',H],ExtDf ),
		Goal =.. [H,DirF,ExtDf],
		( call( Goal ) -> 
			write( ext_goal_succ( Goal ) ), nl
			;
			write( ext_goal_fail( Goal ) ), nl
		)
		;
		write( 'Warning: unrecognised extension, ' ), 
		write( H ), write( '.' ), nl
	).
