:- ensure_loaded( counts_to_prb_lists ).		% /2.
:- ensure_loaded( default_bn ).		% /2.


% quart( ['/media/cdrom/uai01_results/pV28/by_ext/counts/auto_pV28_3po_i500K_s1.counts', '/media/cdrom/uai01_results/pV28/by_ext/counts/auto_pV28_3po_i500K_s40.counts', q_data] ).

quart( [File1, File2, PlotData] ) :-
	counts_to_prb_lists( File1, Prbs1 ),
	counts_to_prb_lists( File2, Prbs2 ),
	default_bn( DefBn ),
	open( PlotData, write, GnuStream ),
	mix_prb_distances_onto_stream( Prbs1, Prbs2, DefBn, GnuStream ),
	close( GnuStream ).


mix_prb_distances_onto_stream( [], [], [], _Out ).
mix_prb_distances_onto_stream( [P-H1|T1], [P-H2|T2], [P-PdefPrts|T3], Out ) :-
	sort( PdefPrts, Prnts ), % just in case
	mix_distances_onto_stream( H1, H2, Prnts, 1, Out),
	mix_prb_distances_onto_stream( T1, T2, T3, Out ).

mix_distances_onto_stream( [], [], [], _Cnt, _Out ).
mix_distances_onto_stream( [H1|T1], [H2|T2], Prnts, Cnt,  Out) :-
	( Prnts = [Cnt|TPrnts] -> 
		X is abs( H1 - 1 ),
		Y is abs( H2 - 1 )
		;
		X is - H1,
		Y is - H2,
		TPrnts = Prnts
	),
	write( Out, X ), write( Out, '  ' ),
	write( Out, Y ), nl( Out ),
	NxCnt is Cnt + 1,
	mix_distances_onto_stream( T1, T2, TPrnts, NxCnt, Out ).
