:- ensure_loaded( library(ordsets) ).	% ord_subtract/3.
:- ensure_loaded( library(ugraphs) ).	% vertices_edges_to_ugraph/3,	
	% add_edges/3, reachable/3.

bn( Nodes, Bn ) :-
	vertices_edges_to_ugraph( Nodes, [], First ),
	vertices_edges_to_ugraph( Nodes, [], Aux ),
	bn( Nodes, Nodes, First, Aux, Bn, _EndAux ).

bn( [], _Nodes, Bn, Aux, Bn, Aux ).
bn( [Vx|Vcs], Nodes, InBn, InAux, OutBn, OutAux ) :-
	bn( Vcs, Nodes, InBn, InAux, MidBn, MidAux ),
	candidate_parents( Vx, Nodes, MidAux, CandParents ),
	choose_parents( CandParents, Parents ),
	create_edges( Parents, Vx, ParEdges, ChildEdges ),
	add_edges( MidBn, ParEdges, OutBn ),
	add_edges( MidAux, ChildEdges, OutAux ).

candidate_parents( Vx, Nodes, Aux, Candidates ) :-
	reachable( Vx, Aux, Reachable ),
	ord_subtract( Nodes, Reachable, Candidates ).

choose_parents( [A|T], [A|Tp] ) :-
	choose_parents( T, Tp ).
choose_parents( [_A|T], Tp ) :-
	choose_parents( T, Tp ).
choose_parents( [], [] ).

create_edges( [], _Vx, [], [] ).
create_edges( [P|Ps], Vx, [Vx-P|TpEs], [P-Vx|TcEs] ) :-
	create_edges( Ps, Vx, TpEs, TcEs ).
