:- use_module( library(lists) ).
:- use_module( library(ugraphs) ).
:- use_module( library(ordsets) ).

bn( X, Y )  :-
	bn( X, X, Y ).
bn([],_All,[]).
bn([RV|RVs], AllParents, BN) :-
	bn(RVs,AllParents,TailBN),
	select( RV, AllParents, RVParents ),
	choose_parents_pre( RV, RVParents, Parents ),
	list_to_ord_set(Parents,OrdParents),
	ord_add_element(TailBN,RV-OrdParents,BN).

choose_parents_pre( 3, _RVParents, [2,5] ).
choose_parents_pre( NotThree, RVParents, Parents ) :-
	NotThree =\= 3,
	choose_parents( RVParents, Parents ).

choose_parents([A,B|CandParents],Parents) :-
	select_a_parent([A,B|CandParents],OneL,RestCPs),
	select_a_parent(RestCPs,TwoL,_RemCps),
	ord_union( OneL, TwoL, Parents ).

choose_parents([A|CandParents],ParentL) :-   
	select_a_parent([A|CandParents],ParentL,_RestCPs).

choose_parents(_CandParents,[]).

select_a_parent(List,OneL,Rest) :-
	length( List, Length ),
	select_parent( Length, List, OneL, Rest ).

select_parent( 7, [H|T], [H], T ).
select_parent( 7, [H|T], Sel, [H|Rest] ) :-
	select_parent( 6, T, Sel, Rest ).
	
select_parent( 6, [H|T], [H], T ).
select_parent( 6, [H|T], Sel, [H|Rest] ) :-
	select_parent( 5, T, Sel, Rest ).
	
select_parent( 5, [H|T], [H], T ).
select_parent( 5, [H|T], Sel, [H|Rest] ) :-
	select_parent( 4, T, Sel, Rest ).

select_parent( 4, [H|T], [H], T ).
select_parent( 4, [H|T], Sel, [H|Rest] ) :-
	select_parent( 3, T, Sel, Rest ).

select_parent( 3, [H|T], [H], T ).
select_parent( 3, [H|T], Sel, [H|Rest] ) :-
	select_parent( 2, T, Sel, Rest ).

select_parent( 2, [H|T], [H], T ).
select_parent( 2, [H|T], Sel, [H|Rest] ) :-
	select_parent( 1, T, Sel, Rest ).

select_parent( 1, [H], [H], [] ).
select_parent( 0, _Empty, [], [] ).

