:- op( 1200, xfy, :: ).

:- ensure_loaded( library(head_to_spec) ).	%/2.
:- ensure_loaded( library(ord_only_add_elem) ).	%/3.

:- dynamic term_expansion/2.
:- dynamic ad:s_label/2.
:- dynamic ad:pred_type/2.

:- ad:bb_put( all_preds, [] ).

term_expansion( Term, Expant ) :-
	Term \== end_of_file,
	Term \= (?-_An1),
	Term \= (:-_An2),
	( Term = (InLabel::Clause) -> 
		Label is InLabel,
		Stochastic = y
		;
		Clause = Term,
		Stochastic = n
	),
	Mod = ad,
	% current_module( Cmod ), 
	( Clause = (Head:-_Body) -> 
		true 
		;
		Head = Clause
	),
	head_to_spec( Head, Spec ),
	pl( sicstus(_S), Expant = [(:- dynamic(Mod:Spec)),Mod:Clause] ),
	pl( yap(_Y), (Expant = Mod:Clause) ),
	ad:bb_get( all_preds, ADPreds ),
	( ord_only_add_elem( ADPreds, Spec, NwADPreds ) ->
		ad:bb_put( all_preds,  NwADPreds )
		;
		true
	),
	% ( predicate_property( Head, dynamic ) -> 
		% Expant = Mod:Clause
		% ;
		% Expant = [(:- dynamic(Mod:Spec)),Mod:Clause]
	% ),
	( Stochastic == y -> 
		( ad:pred_type(Spec,s) ->
			assert( Mod:s_label(Spec,Label) )
			;
			Spec = Name/Arity,
			ConfArity is Arity - 1,
			( ad:pred_type(Spec,ns) -> 
				Goal = Spec, Cul1 = stochastic, Cul2 = non_stochastic,
				Mess = 'predicate already defined non_stochastic',
				Error = consistency_error(Goal,Cul1,Cul2,Mess),
				print_message( error, Error )
				;
				( ad:pred_type((Name/ConfArity),ns) ->
					Goal = Spec, Cul1 = stochastic(Name/ConfArity),
					Cul2 = non_stochastic(Spec),
					Mess = 'conflicting predicate already defined non_stochastic',
					Error = consistency_error(Goal,Cul1,Cul2,Mess),
					print_message( error, Error )
					;
					assert( Mod:s_label(Spec,Label) ),
					assert( Mod:pred_type(Spec,s) )
				)
			)
		)
		;
		( ad:pred_type(Spec,ns) ->
			true
			;
			( ad:pred_type(Spec,s) -> 
				Goal = Spec, Cul1 = non_stochastic, Cul2 = stochastic,
				Mess = "predicate already defined stochastic",
				Error = consistency_error(Goal,Cul1,Cul2,Mess),
				print_message( error, Error )
				;
				Spec = Name/Arity,
				ConfArity is Arity + 1,
				( ad:pred_type(Name/ConfArity,s) ->
					Goal = Spec, Cul1 = non_stochastic(Spec),
					Cul2 = stochastic(Name/ConfArity),
					Mess = "conflicting predicate already defined stochastic",
					Error = consistency_error(Goal,Cul1,Cul2,Mess),
					print_message( error, Error )
					;
					assert( Mod:pred_type(Spec,ns) )
				)
			)
		)
	).
