:- ensure_loaded( library(ordsets) ).	% /3.

% [1-[],2-[1],3-[2,5],4-[],5-[4],6-[4],7-[3],8-[3,6]]

band_bn( Bn, [Pless,NoPorC,Cless] ) :-
	sieve_parentless( Bn, Pless, WithParents ),
	sieve_childless( WithParents, Bn, Cless, NoPorC ).

sieve_parentless( [], [], [] ).
sieve_parentless( [H|T], Pless, WithParents ) :-
	( H = Node-[] -> 
		Pless = [Node|Tpl],
		WithParents = Twp
		;
		Pless = Tpl,
		WithParents = [H|Twp]
	),
	sieve_parentless( T, Tpl, Twp ).

sieve_childless( [], _Bn, [], [] ).
sieve_childless( [Node-Parents|T], Bn, WPorC, Cless ) :-
	( childless(Bn,Node) -> 
		WPorC = [Node-Parents|Tporc],
		Cless = Tcl
		;
		Cless = [Node-Parents|Tcl],
		WPorC = Tporc
	),
	sieve_childless( T, Bn, Tporc, Tcl ).

childless( [], _B ).
childless( [_A-Parents|T], B ) :-
	\+ ord_member( B, Parents ), 
	childless( T, B ).
