% :- ensure_loaded( library(lists) ).	% append/3.
:- ensure_loaded( '../init_lib' ).		% library_directory/1.
:- ensure_loaded( library(system) ).	% system/1.
:- ensure_loaded( library(lists) ).	% select/3.
:- ensure_loaded( band_bn ).			% /2.
% :- ensure_loaded( afn ).				% /2.
:- ensure_loaded( flatoms ).			% /2.

%  bn_to_dot_dag( [1-[],2-[1],3-[2,5],4-[],5-[4],6-[4],7-[3],8-[3,6]], tara ).

bn_to_dot_dag( Bn, Against, File ) :-
	% atom_codes( File, FileCs ),
	absolute_file_name( library(dot_preample), DotPr, [access(exist)] ),
	flatoms( ['cat ',DotPr,' > ',File], Cat ),
	% append( "cat dot_preample > ", FileCs, CatCs ),
	% atom_codes( Cat, CatCs ),
	system( Cat ),
	open( File, append, FStream ),
	current_output( Old ),
	set_output( FStream ),
	band_bn( Bn, Bands ),
	bn_bands_to_dot_dag_output( Bands, Against ),
	set_output( Old ),
	close( FStream ).

bn_bands_to_dot_dag_output( Bands, Against ) :-
	bands_to_zones( Bands, Zones ),
	dot_zones_to_colours( Zones ),
	dot_edges( Bands, Against ),
	write( '}' ), nl.

bands_to_zones( [Pless,Adjusted,Cless], [Pless,AdjZone,ClessZone] ) :-
	bands_to_zones1( Adjusted, AdjZone ),
	bands_to_zones1( Cless, ClessZone ).

bands_to_zones1( [], [] ).
bands_to_zones1( [H-_HPs|T], [H|M] ) :-
	bands_to_zones1( T, M ).

dot_zones_to_colours( [PlessZ,AdjZ,ClessZ] ) :-
	dot_zone_to_colour( PlessZ, red ),
	dot_zone_to_colour( AdjZ, orange ),
	dot_zone_to_colour( ClessZ, green ).

dot_zone_to_colour( [], _Colour ).
dot_zone_to_colour( [H|T], Colour ) :-
	tab( 2 ), write( H ), 
	tab( 1 ), write( [color=Colour] ),
	nl,
	dot_zone_to_colour( T, Colour ).

% dot_edges( [_Pless,Adj,Cless], Against ) :-
dot_edges( [Pless,Adj,Cless], Against ) :-
	kv_newval_empty_list( Pless, KvPless ),
	dot_edges_one( KvPless, Against ),
	dot_edges_one( Adj, Against ),
	dot_edges_one( Cless, Against ).

dot_edges_one( [], _Against ).
dot_edges_one( [Node-Parents|T], Against ) :-
	select( Node-AgainstPrs, Against, _Ragain ),
	dot_node_parents_edges( Parents, AgainstPrs, Node ),
	dot_edges_one( T, Against ).

dot_node_parents_edges( [], Against, Node ) :-
	dot_node_parents_edges_vanished( Against, Node ).
dot_node_parents_edges( [H|T], Against, Node ) :-
	tab( 2 ), write( H ), write( '->' ), write( Node ),
	( select(H,Against,RemAgainst) ->
		nl
		;
		RemAgainst = Against,
		write( ' [color=magenta]' ), nl
	),
	dot_node_parents_edges( T, RemAgainst, Node ).

dot_node_parents_edges_vanished( [], _Node ).
dot_node_parents_edges_vanished( [H|T], Node ) :-
	tab( 2 ), write( H ), write( '->' ), write( Node ),
	write( ' [color=yellow]' ), nl,
	dot_node_parents_edges_vanished( T, Node ).

kv_newval_empty_list( [], [] ).
kv_newval_empty_list( [H|T], [H-[]|Te] ) :-
	kv_newval_empty_list( T, Te ).
