term_in_file_contiguous_counts( File, Term, Count ) :-
	open( File, read, Stream ),
	term_in_stream_contiguous_counts( Stream, Term, [], Count ),
	close( Stream ).

term_in_stream_contiguous_counts( Stream, Term, Acc, Counts ) :-
	read( Stream, ReadTerm ), 
	( \+ \+ ReadTerm = Term -> 
		increase_contiguous_count( Acc, ReadTerm, NxAcc ),
		term_in_stream_contiguous_counts( Stream, Term, NxAcc, Counts )
		;
		( ReadTerm = end_of_file ->
			Counts = Acc
			;
			term_in_stream_contiguous_counts( Stream, Term, Acc, Counts )
		)
	).

increase_contiguous_count( [], ReadTerm, [ReadTerm-1] ).
increase_contiguous_count( [H-Hcount|T], ReadTerm, NxAcc ) :-
	( \+ \+ H = ReadTerm ->
		NxHcount is Hcount + 1,
		NxAcc = [H-NxHcount|T]
		;
		NxHcount is 1,
		NxAcc = [ReadTerm-1,H-Hcount|T]
	).
