:- use_module( library(random) ).

% this will fail on select_unified, that had no unified, arguments.
select_id( Args, A, Lbls, Nth, H, T, Sel, Sid, Tail ) :-
	% Unifs can be eleminated, keep it here, just in case,
	% we decide to hold it, as part of the path.
	( var(H) ->
		add_unifying( Args, A, Lbls, Nth, 0, 0, _Unifs, ULs, Sum  ),
		% first zero is a donot-exclude-any-id trick
		select_unified( Sum, ULs, Sid, Sprb ),
		length( ULs, Cardin ),
		Tail = T
		;
		( T == [] ->
			% write( run_h(H) ), nl,
			H = Excl/_ExcPrb,
			add_unifying( Args, A, Lbls, Nth, Excl, 0, _Unifs, ULs, Sum  ),
			select_unified( Sum, ULs, Sid, Sprb ),
			% write( select_unified( Sum, ULs, Sid, Sprb ) ), nl,
			length( ULs, ULlgt ),
			( ULlgt =:= 1 -> Cardin is 0 ; Cardin is  2 )
			% Tail = _
			;
			Tail = T,
			( (H = Sid/Sprb;H = Sid:Sprb) ->
				Cardin is 2
				;
				Cardin is 1,
				Sid = H
			)
		)
	),
	( Cardin > 1 -> 
		Sel = Sid/Sprb
		;
		(Cardin =:= 0 -> 
			Sel = Sid:Sprb
			;
			Sel = Sid
		)
	).
	% write( out_sid(select_id( Args, A, Lbls, Nth, H, T, Sel, Sid, Tail )) ), nl.

add_unifying( [], _U, _Empty, _Nth, _Excl, Sum, [], [], Sum ).
add_unifying( [H|T], U, [L|Ls], Nth, Excl, Acc, Unifs, ULs, Sum ) :-
	NxN is Nth + 1,
	( (Nth =\= Excl, \+ \+ H = U) ->
		NxAcc is Acc + L,
		Unifs = [H|TUnifs],
		ULs = [L-Nth|TUls]
		;
		NxAcc is Acc,
		Unifs = TUnifs,
		ULs = TUls
	),
	add_unifying( T, U, Ls, NxN, Excl, NxAcc, TUnifs, TUls, Sum ).

select_unified( Sum, ULs, SelId, PrbSel ) :-
	random:random( R ),
	NormR is R * Sum, 
	select_from_unified_label( ULs, NormR, SelId, PrbSel ).

select_from_unified_label( [L-Id], _R, Id, L ) :- !.
select_from_unified_label( [L-Lid|T], R, Id, SeL ) :-
	( R < L -> 
		Id = Lid, SeL = L, !
		;
		NxR is R - L,
		select_from_unified_label( T, NxR, Id, SeL )
	).
