:- op( 1000, xfy, :: ).

:- ensure_loaded( library(head_to_spec) ).
:- ensure_loaded( library(defined_elsewhere) ).

head_expansion( H, ExpH, Dyn, Pbc ) :-
	retract( cc(Id) ),
	( H = (Prb::Hd) -> 
		PrvPbc = slp_info:pbc(PredName/Arity)
		;
		PrvPbc = (:- true),
		Prb is 1, 
		Hd = H
	),
	Hd =.. [PredName|Args],
	ExpH =.. [PredName,Id,Prb|Args],
	NxtId is Id + 1,
	length( [Id,Prb|Args], Arity ),
	asserta( cc(NxtId) ),
	( predicate_property( slp:ExpH, _Any) ->
		Dyn = (:- true), Pbc = (:- true)
		;
		Pbc = PrvPbc,
		head_to_spec( ExpH, SpExH ),
		Dyn = (:- dynamic slp:SpExH)
	).
body_expansion( A, ExpA ) :-
	( A = (B,C) ->
		body_expansion( B, ExpB ),
		body_expansion( C, ExpC ),
		ExpA = (ExpB,ExpC)
		;
		( A = (B->C;D) ->
			body_expansion( B, ExpB ),
			body_expansion( C, ExpC ),
			body_expansion( D, ExpD ),
			ExpA = (ExpB->ExpC;ExpD)
			;
			( A = (B;C) ->
				body_expansion( B, ExpB ),
				body_expansion( C, ExpC ),
				ExpA = (ExpB;ExpC)
				;
				( A = (\+ B) -> 
					body_expansion( B, ExpB ),
					ExpA = (\+ ExpB)
					;
					( A = findall(B,C,D) -> 
						body_expansion( C, ExpC ),
						ExpA = findall(B,ExpC,D)
						;
						( defined_elsewhere(A) ->
						% defined_elsewhere( A, _Mod ) ->
							ExpA = A
							;
							A =.. [PredName|Args],
							ExpA =.. [PredName,_,_|Args]
						)
					)
				)
			)
		)
	).

term_expansion( A, [Dyn,Pbc,ExpA] ) :-
	\+ A = end_of_file,
	\+ A = (:- _Dir),
	\+ A = (?- _Q),
	( A = (B:-C) -> 
		head_expansion( B, ExpB, Dyn, Pbc ),
		body_expansion( C, ExpC ),
		ExpA = (ExpB :- ExpC)
		;
		head_expansion( A, ExpA, Dyn, Pbc )
	).
